/*
 *  jquery-input-validation - v1.0.0
 *  Live validation for input fields
 *  
 *
 *  Made by Amanda Louise Acosta Morais
 *  Under GNU GENERAL PUBLIC LICENSE License
 */

!function(u,e,t,l){"use strict";var n="inputValidation";function r(e,t){return this._name=n,this._items=e,t&&u.extend(this._configuration,t),this._initialize(),this._configuration.chainable?e:this}u.fn[n]=function(e){return new r(this,e)},u.extend(u.fn[n],{addType:function(e,t,n){var a=new r;a._methods[e]=t,a._messages[e]=n!==l?n:a._messages[e]}}),u.extend(r.prototype,{_methods:{email:function(e){return""===e||/^(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])/.test(e)},url:function(e){return""===e||/^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})).?)(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(e)},date:function(e){return""===e||(this.datemdy(e)||this.dateymd(e))},dateymd:function(e){return""===e||/^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])$/.test(e)},datemdy:function(e){return""===e||/^((0?[1-9]|1[012])[- /.](0?[1-9]|[12][0-9]|3[01])[- /.](19|20)?[0-9]{2})*$/.test(e)},number:function(e){return""===e||/^(?:-?\d+|-?\d{1,3}(?:,\d{3})+)?(?:\.\d+)?$/.test(e)},digits:function(e){return""===e||/^\d+$/.test(e)},notempty:function(e){return/^(?!\s*$).+/.test(e)},notempty_integer:function(e){return this.notempty(e)||this.gtzero(e)},gtzero:function(e){return/^[1-9]\d*$/.test(e)},minlength:function(e,t){return t<=e.length},maxlength:function(e,t){return e.length<=t},phoneUS:function(e){return""===e||9<(e=e.replace(/\s+/g,"")).length&&e.match(/^\(?\d{3}\)?[-\.]? *\d{3}[-\.]? *[-\.]?\d{4}$/)}},_messages:{email:"Please enter a valid email address.",url:"Please enter a valid URL.",date:"Please enter a valid date",datemdy:"Please enter a valid date mm-dd-YYYY",dateymd:"Please enter a valid date YYYY-mm-dd",number:"Please enter a valid number.",digits:"Please enter only digits.",equalTo:"Please enter the same value again.",phoneUS:"Please specify a valid phone number",notempty:"This field can not be empty",gtzero:"Please enter a number greater than zero",maxlength:"Please enter no more than {0} characters.",minlength:"Please enter at least {0} characters.",notempty_integer:"This field can not be empty or zero"},_name:null,_items:{},_configuration:{chainable:!0},_initialize:function(){var e=this;u(e._items).each(function(){u(this).on("submit",function(){u(this).find(":input.validate").each(function(){e._check(u(this))}),e._formValidation(u(this))}),u(this).find(":input.validate").on("keyup",function(){e._check(u(this))}),u(this).find(":input.validate").on("focusout",function(){e._check(u(this))})})},_check:function(r){var i=this,e=r.data("validate-type"),t=r.val(),n=r.data("constraint"),s="",d="input-error";if(i.settings!==l&&(s=i.settings.borderinline?i.settings.borderinline:"",d=i.settings.border?i.settings.border:"input-error"),Array.isArray(e))for(var a=0;a<e.length;a++)o(e[a],t,n);else o(e,t,n);function o(e,t,n){if(i._methods[e](t,n))r.next("#error_validate").remove(),"input-error"===d&&""!==s&&r.css("border",""),"input-error"!==d&&r.removeClass(d),"input-error"===d&&""===s&&r.removeClass("input-error");else{var a=r.data("validate-error-msg-text")!==l?r.data("validate-error-msg-text"):"";r.next("#error_validate").length<=0&&u(i._defaultMessage(a,e,n,r)).insertAfter(r),"input-error"===d&&""!==s&&r.css("border",s),"input-error"!==d&&r.addClass(d),"input-error"===d&&""===s&&r.addClass("input-error")}}},_formValidation:function(e){var t=[];e.find(".input-error").each(function(){t.push(u(this).attr("name"))}),0<t.length&&event.preventDefault()},_defaultMessage:function(e,t,n,a){var r=a.data("validate-error-msg-class")!==l?a.data("validate-error-msg-class"):"text-danger";""===e&&(e=this._messages[t].replace("{0}",n));return"<div id='error_validate'><small class='form-text "+r+"'>"+e+"</small></div>"},destroy:function(){this._items={}}})}(jQuery,window,document);